﻿
package
{
	import flash.display.*;
	import flash.events.*;
	import flash.filters.*;
	import flash.geom.*;
	
	public class Main extends MovieClip
	{		
		public static const ANCHO:int = 400;
		public static const ALTO:int = 300;
		
		// Bitmap
		private var _bmpOrigen:Bitmap = new Bitmap();
		private var _bmpDataBuffer:BitmapData = new BitmapData(ANCHO,ALTO,true,0);
		private var _bmpBuffer:Bitmap = new Bitmap(_bmpDataBuffer);
		private var _bmpDataDestino:BitmapData = new BitmapData(ANCHO,ALTO,true,0);
		private var _bmpDestino:Bitmap = new Bitmap(_bmpDataDestino);
		
		// COLORES
		private static const VERDE:uint = 0xFF00ff00;
		private static const NEGRO:uint = 0xFF000000;
				
		// FILTROS
		private var _ct:ColorTransform = new ColorTransform();
		
		// 
		private var _init:Boolean = false;
		private var _cont:int = 0;
		private var _cont_buffer:int = 0;
		private var _pixels:Array = new Array();
		
		
		public function Main()
		{
			init();
		}
		
		private function init():void 
		{
			_ct.alphaMultiplier = 0.9;
						
			_bmpOrigen.bitmapData = new BatmanImg(0,0);
			addChild(_bmpDestino);
			addChild(_bmpBuffer);
			
			// Eventos
			stage.addEventListener(MouseEvent.CLICK, evClick);
						
			parsearImagen();
		}
		
		private function evClick(e:Event):void 
		{
			if (!_init)	{
				_init = true;
				stage.addEventListener(Event.ENTER_FRAME, evEnterFrame);
			}
		}
		
		private function parsearImagen():void 
		{
			var sw: int = _bmpOrigen.width;
			var sh: int = _bmpOrigen.height;
			var c: uint;
			
			for(var sy = 0 ; sy < sh ; sy++ )
			{
				for(var sx = 0 ; sx < sw ; sx++ )
				{
					c = _bmpOrigen.bitmapData.getPixel32( sx, sy );
					var tolerancia:int = 225;
					if( ( ( c >> 0 ) & 0xff) < tolerancia) 
					{
						var xx:int = Math.round(Math.random()*ANCHO);
						var yy:int = Math.round(Math.random()*ALTO);
												
						_bmpDataDestino.setPixel32(xx,yy,c);
		
						_pixels.push(new Pixel(xx, yy, sx, sy, c));
						_cont++;
					}
					else{
						//_bmpDataDestino.setPixel32(sx,sy,VERDE);
					}
				}
			}
			trace(_pixels.length);
		}
		
		private function evEnterFrame(e:Event):void 
		{
			var pixels_recolectados:int = 0;
			
			var num_pixels:int = ++_cont_buffer*50;
			if (num_pixels > _pixels.length) num_pixels = _pixels.length;
			
			for (var i:int=0; i < num_pixels; i++)
			{
				var p:Pixel = _pixels[i];
				if (!p.recolectar)
				{
					_bmpDataBuffer.setPixel32(p.x, p.y, p.c);
					if (!p.activo) {
						p.activo = true;
						_bmpDataDestino.setPixel32(p.ix, p.iy, 0);	// Borra el pixel original
					}
					p.mover();
				}
				else {
					pixels_recolectados++;
					_bmpDataDestino.setPixel32(p.x,p.y,p.c);
				}
			}

			if (_init && _pixels.length == pixels_recolectados) figuraFormada();
			_bmpDataBuffer.colorTransform(_bmpDataBuffer.rect, _ct);
		}
		
		private function figuraFormada():void 
		{
			trace("Figura formada");
			_pixels = new Array();
			stage.removeEventListener(Event.ENTER_FRAME, evEnterFrame);
		}
	}
}